"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.color_log = exports.console_colors = exports.promisified = exports.sleep = exports.copy_file_or_directory = exports.remove_file_or_directory = exports.get_file_stats = exports.validate_path = exports.get_ts_projects_paths = exports.get_ts_project_paths = exports.get_ts_config = exports.get_config = void 0;
var path = __importStar(require("path"));
var fs = __importStar(require("fs"));
var commander_1 = require("commander");
var typescript_1 = __importDefault(require("typescript"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var pify_1 = __importDefault(require("pify"));
var rimraf_1 = __importDefault(require("rimraf"));
var cosmiconfig_1 = require("cosmiconfig");
var promisified = {
    fs: __assign(__assign({}, pify_1.default(fs)), { exists: pify_1.default(fs.exists, { errorFirst: false }) }),
    fse: pify_1.default(fs_extra_1.default),
    rimraf: pify_1.default(rimraf_1.default),
};
exports.promisified = promisified;
// https://stackoverflow.com/a/41407246/3111787
// https://en.wikipedia.org/wiki/ANSI_escape_code#Colors
var console_colors = {
    Reset: '\x1b[0m',
    Bright: '\x1b[1m',
    Dim: '\x1b[2m',
    Underscore: '\x1b[4m',
    Blink: '\x1b[5m',
    Reverse: '\x1b[7m',
    Hidden: '\x1b[8m',
    FgBlack: '\x1b[30m',
    FgRed: '\x1b[31m',
    FgGreen: '\x1b[32m',
    FgYellow: '\x1b[33m',
    FgBlue: '\x1b[34m',
    FgMagenta: '\x1b[35m',
    FgCyan: '\x1b[36m',
    FgWhite: '\x1b[37m',
    BgBlack: '\x1b[40m',
    BgRed: '\x1b[41m',
    BgGreen: '\x1b[42m',
    BgYellow: '\x1b[43m',
    BgBlue: '\x1b[44m',
    BgMagenta: '\x1b[45m',
    BgCyan: '\x1b[46m',
    BgWhite: '\x1b[47m',
    FgBrightBlack: '\x1b[90m',
    FgBrightRed: '\x1b[91m',
    FgBrightGreen: '\x1b[92m',
    FgBrightYellow: '\x1b[93m',
    FgBrightBlue: '\x1b[94m',
    FgBrightMagenta: '\x1b[95m',
    FgBrightCyan: '\x1b[96m',
    FgBrightWhite: '\x1b[97m',
    BgBrightBlack: '\x1b[100m',
    BgBrightRed: '\x1b[101m',
    BgBrightGreen: '\x1b[102m',
    BgBrightYellow: '\x1b[103m',
    BgBrightBlue: '\x1b[104m',
    BgBrightMagenta: '\x1b[105m',
    BgBrightCyan: '\x1b[106m',
    BgBrightWhite: '\x1b[107m',
};
exports.console_colors = console_colors;
var version = require('../package.json').version;
var defaultProject = (function () {
    // process.argv = ['node_path', 'script_path', ...args]
    var lastArg = process.argv.slice(2).slice(-1)[0];
    if (lastArg && !lastArg.startsWith('-')) {
        return lastArg;
    }
    return 'tsconfig.json';
})();
var program = new commander_1.Command();
program
    .option('-w, --watch', 'Watch input files.')
    .option('-b, --build', 'Build one or more projects and their dependencies, if out of date')
    .option('-p , --project <path>', "FILE OR DIRECTORY Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'", defaultProject)
    .version(version, '-v, --version');
program.parse(process.argv);
// @ts-ignore
var options = program.opts();
function get_config() {
    return __awaiter(this, void 0, void 0, function () {
        var cwd, ts_config, explorer, result, project_config, default_config, config;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cwd = process.cwd();
                    ts_config = get_ts_config(cwd, options.project);
                    explorer = cosmiconfig_1.cosmiconfig('tscp');
                    return [4 /*yield*/, explorer.search(cwd)];
                case 1:
                    result = _a.sent();
                    project_config = (result || {}).config;
                    default_config = {
                        cwd: cwd,
                        cli_options: options,
                        compiled_files: ['**/*.ts', '**/*.tsx', '**/*.js', '**/*.jsx'],
                        ignored_files: ['node_modules'],
                        ts_config: ts_config,
                    };
                    config = __assign(__assign({}, default_config), project_config);
                    config.ignored_files = __spreadArray(__spreadArray([], __read(config.compiled_files)), __read(config.ignored_files));
                    return [2 /*return*/, config];
            }
        });
    });
}
exports.get_config = get_config;
function get_ts_config(currentDir, project) {
    var configFile = typescript_1.default.findConfigFile(currentDir, typescript_1.default.sys.fileExists, project);
    if (!configFile)
        throw Error('tsconfig.json not found');
    var config = typescript_1.default.readConfigFile(configFile, typescript_1.default.sys.readFile).config;
    return typescript_1.default.parseJsonConfigFileContent(config, typescript_1.default.sys, currentDir);
}
exports.get_ts_config = get_ts_config;
function build_project_path(cwd, project_path, ts_config) {
    var currentDirName = path.basename(path.resolve());
    var referenceName = path.relative(process.cwd(), cwd);
    var projectName = path.join(currentDirName, referenceName);
    var _a = ts_config.options, rootDir = _a.rootDir, outDir = _a.outDir;
    if (!rootDir) {
        throw new Error("No 'rootDir' configured in reference '" + referenceName + "'");
    }
    if (!outDir) {
        throw new Error("No 'outDir' configured in reference '" + referenceName + "'");
    }
    return {
        project_name: projectName,
        base_path: cwd,
        ts_config_path: project_path,
        root_dir: rootDir,
        out_dir: outDir,
    };
}
function get_ts_project_paths(options) {
    var cwd = options.cwd, cli_options = options.cli_options, ts_config = options.ts_config;
    return build_project_path(cwd, cli_options.project, ts_config);
}
exports.get_ts_project_paths = get_ts_project_paths;
function get_ts_projects_paths(options) {
    var ts_config = options.ts_config;
    if (!ts_config.projectReferences) {
        throw new Error('No project references configured');
    }
    return ts_config.projectReferences.map(function (reference) {
        if (!reference.path) {
            throw new Error('Could not find project reference path');
        }
        if (!reference.originalPath) {
            throw new Error('Could not find project reference originalPath');
        }
        var cwd = path.dirname(reference.path);
        var referenceConfig = get_ts_config(cwd, reference.originalPath);
        return build_project_path(cwd, reference.originalPath, referenceConfig);
    });
}
exports.get_ts_projects_paths = get_ts_projects_paths;
function color_log(msg, color) {
    return "" + color + msg + console_colors.Reset;
}
exports.color_log = color_log;
/**
 * Makes sure that the given folder exists - creates if not
 * @param path {string}
 */
function validate_path(path) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, promisified.fs.exists(path)];
                case 1:
                    if (!!(_a.sent())) return [3 /*break*/, 3];
                    return [4 /*yield*/, promisified.fs.mkdir(path, { recursive: true })];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.validate_path = validate_path;
/**
 * Error-safe `fs.lstat` - returns stats if the file exists, otherwise null
 * @param file_path
 */
function get_file_stats(file_path) {
    return __awaiter(this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, promisified.fse.lstat(file_path)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    e_1 = _a.sent();
                    return [2 /*return*/, Promise.resolve()];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.get_file_stats = get_file_stats;
/**
 *
 * @param file_path
 */
function remove_file_or_directory(file_path) {
    return __awaiter(this, void 0, void 0, function () {
        var stats;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, get_file_stats(file_path)];
                case 1:
                    stats = _a.sent();
                    if (!stats) {
                        return [2 /*return*/, Promise.resolve()];
                    }
                    // console.log('DELETE', file_path);
                    return [2 /*return*/, promisified.rimraf(file_path)];
            }
        });
    });
}
exports.remove_file_or_directory = remove_file_or_directory;
function copy_file_or_directory(source_path, destination_path) {
    return __awaiter(this, void 0, void 0, function () {
        var stats, is_directory;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, get_file_stats(source_path)];
                case 1:
                    stats = _a.sent();
                    if (!stats) {
                        return [2 /*return*/];
                    }
                    is_directory = stats.isDirectory();
                    if (is_directory) {
                        return [2 /*return*/, promisified.fs.mkdir(destination_path)];
                    }
                    // console.log('COPY', link_target, 'to', link_path);
                    return [2 /*return*/, fs_extra_1.default.copy(source_path, destination_path)];
            }
        });
    });
}
exports.copy_file_or_directory = copy_file_or_directory;
function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
exports.sleep = sleep;
